::main_script <- this;
::main_script_entity <- self;
::root_table <- getroottable();
::tf_player_manager <- Entities.FindByClassname(null, "tf_player_manager");
::tf_gamerules <- Entities.FindByClassname(null, "tf_gamerules");
tf_gamerules.ValidateScriptScope();
::worldspawn <- Entities.FindByClassname(null, "worldspawn");
worldspawn.ValidateScriptScope();

ClearGameEventCallbacks();

if (!("MAX_PLAYERS" in root_table))
{
    ::MAX_PLAYERS <- MaxClients().tointeger();

    //Thanks Ficool2 for the idea.
    foreach (k, v in ::NetProps.getclass())
        if (k != "IsValid")
            root_table[k] <- ::NetProps[k].bindenv(::NetProps);

    foreach (_, cGroup in Constants)
        foreach (k, v in cGroup)
            root_table[k] <- v != null ? v : 0;
}

IncludeScript("arena_vscript/_lizardlib/listeners.nut");
IncludeScript("arena_vscript/_lizardlib/timers.nut");
IncludeScript("arena_vscript/_lizardlib/players.nut");

function IncludeConfig(path)
{
    local configErrorMessageTimer = AddTimer(1, function(path)
    {
        local message = "\x07FF1111Failed to load config: " + path;
        foreach (player in GetPlayers())
            ClientPrint(player, HUD_PRINTTALK, message);
        printl(message);
    }, path);
    IncludeScript(path);
    configErrorMessageTimer[2] = null;
}