::HUD_PATH <- "resource/arena_vscript/arena_vscript_hud.res";
::HUMILIATION_LENGTH <- 5;                    //The time between mini-rounds

::SETUP_LENGTH <- 15;                         //Setup time
::HOLD_PLAYERS_DURING_SETUP <- false;         //Locks players in place during setup
::VICTORY_SCORE <- 5;                         //The amount of mini-rounds wins required for full-round victory
::ON_CAPTURE_RESPAWN <- false;                //Respawns players when a point is captured
::UNLOCK_ON_DEATH <- false;                   //Unlocks the point(s) when a certain amount of players died
::UNLOCK_TIMER_TIME <- 60;                    //Unlocks the point(s) on a timer. 0 = disabled. Stock arena is 60 [seconds]

::FIRST_BLOOD_DURATION <- 5;                  //First Blood duration. 0 = disabled. Stock arena is 5 [seconds]

::LAST_MANN_STANDING_ENABLED <- true;         //Gives the last surviving player(s) on the team buffs
::LAST_MANN_STANDING_PLAYERS_LEFT <- 1;       //The amount of survivors left on the team to trigger the buffs
::LAST_MANN_STANDING_PLAYER_TOTAL_COUNT <- 6; //The amount of players on the server needed for the mechanic to activate
::LAST_MANN_STANDING_BUFFS <- [               //Buffs given out for the last player alive on their team
    Constants.ETFCond.TF_COND_OFFENSEBUFF,
    Constants.ETFCond.TF_COND_SPEED_BOOST
];

function CalculateDeathQuota(playerCount)     //Calculates the amount of deaths before the point(s) open if UNLOCK_ON_DEATH is enabled
{
    return playerCount / 6 * 2;
}